#!/usr/bin/env python
# coding: shift-jis

import sys
import os
import struct
import re

# .qtx format
# / s/̓Rgs
# / Psڂ̓W
# 
# / RgsQsڂ͉ȂB
# 
# / Rsڂ炪
# / s
# / IP
# / IQ
# / IR
# / IS
# / IT
# / Ȃs ܂łŖPBȉJԂBŏȊIT͉sEOF̍sɋsŒuĂƁB
# ̂ے肵萧łȂ̂͂ǂꂩiOl̖jB
# Rľ\
# @ľ\
# Rl̍sה\
# @l̑B\
# Rl̐ӔC\

# V[Yf[^̃CAEg
# 
# ł́AV[Y̖f[^̃CAEgĂ܂Bf[^舵vO쐬ꍇ̎QlɂȂ΍KłB
# 
# f[^(*.5tq)́AWwb_~W{f[^Qō\Ă܂B
# 
# EWwb_
# 16+2+2+2+12+8+256-16-2-2-2-12-8=256 bytes per header
# typedef struct {
#    unsigned charnpszName[16];// ެٖ
#    intreserved_1;
#    intnCount;// Yެق̖萔
#    intnOffset;// Yެق̐擪ʒu
#    unsigned charnpsz5td[12];// v[[f[^t@C
#    unsigned charnpszID[8];// hci"5TAKUQDT"j
#    unsigned charreserved_2[256-16-2-2-2-12-8];
# } GENREHEAD;
# 
# npsz5tdnpszID́A擪Wɂ̂FĂ܂AÔ߂ɑSẴWwb_ɕtĂĂB
# 
# 
# Ef[^tH[}bg
# 116 + 28 * 5 = 256 bytes per question
# typedef struct {
#    unsigned charszQuiz[116];// 蕶
#    unsigned charszList[28 * 5];// I
# } QSCRIPT;
# 
# f[^0x80ƂxorňÍĂ܂B
# A0x20(pXy[X)͈ÍĂ܂B
#  0x8d ́Axor 0x80 ƁA0x0d ɂȂAłȂS~̂Ŏ菜܂B
# 

# print '<5TAKU>.QT1`<5TAKU>.QT8 t@C qtx25tq.exe ƓtH_ɒu'
# print '<5TAKU>͂̕ĂB'
# rfile = raw_input()

name = sys.argv[1]

rfile = name[:-4]

f_qt = []
header_count = 8
for i in xrange(1, header_count+1):
    f_qt.append(open(rfile + '.QT' + str(i), 'r'))

f_5tq = open(rfile + '.5TQ', 'wb+')

# exit: sys.exit()
# tuple: ( , ) can omit
# ASCII    :0x00-0x7f
# KATAKANA :0xa1-0xdf
# KANJI 1  :0x81-0x9f,0xe0-0xfc
# KANJI 2  :0x40-0x7e

def padding_space(text, counts):
    return text.ljust(counts)

genres = []
genre_length = 16
quiz_contents = []
genre_bytes = 256

question_length = 116
question_count = 1
question_counts = []
question_bytes = 256
quiz_datas = ''
selection_length = 28

packed_0x20 = struct.pack('B', 0x20)

def print_selection_error_message(qtx_index, question_state, selection_length):
    print 'Error: Header : ' + str(qtx_index) + ' : ' \
         + genres[qtx_index] + ' Question :' + str(question_count) + \
         ' Selection :' + str(question_state - 1) + ' is larger than ' + \
         str(selection_length) +  ' bytes.'

# .qtx file
for qtx_index, f_qtx in enumerate(f_qt):
    all_line = f_qtx.read()
    lines = all_line.split('\n')
    
    line_no = 0
    question_state = 0

    question_texts = []   
    selection1_text = []
    selection2_text = []
    selection3_text = []
    selection4_text = []
    selection5_text = []

    if not lines:
        # header doesn't exist
        print 'Error: Header : ' + str(qtx_index) + ' not exists.'
        sys.exit()

    for line in lines:
        # comment
        if line.startswith('/'):
            continue

        line_no += 1
        # genre name
        if line_no == 1:
            if len(line) > genre_length:
                # header length error
                print 'Error: Header : ' + str(qtx_index) + ' : ' + line + ' is larger than ' + str(genre_length) +  ' bytes.'
                sys.exit()

            genres.append(padding_space(line, genre_length))
            continue
        
        # empty line
        if line_no == 2:
            continue
        
        # questions
        question_state += 1
        if question_state == 1:
            if len(line) > question_length:
                # question length error
                print 'Error: Header : ' + str(qtx_index) + ' : ' + genres[qtx_index] + \
                    ' Question :' + str(question_count) + ' is larger than ' + str(question_length) +  ' bytes.'
                sys.exit()
            question_texts.append(padding_space(line, question_length))
            continue
        elif question_state == 2:
            if len(line) > selection_length:
                # selection length error
                print_selection_error_message(qtx_index, question_state, selection_length)
                sys.exit()
            selection1_text.append(padding_space(line, selection_length))
            continue
        elif question_state == 3:
            if len(line) > selection_length:
                # selection length error
                print_selection_error_message(qtx_index, question_state, selection_length)
                sys.exit()
            selection2_text.append(padding_space(line, selection_length))
            continue
        elif question_state == 4:
            if len(line) > selection_length:
                # selection length error
                print_selection_error_message(qtx_index, question_state, selection_length)
                sys.exit()
            selection3_text.append(padding_space(line, selection_length))
            continue
        elif question_state == 5:
            if len(line) > selection_length:
                # selection length error
                print_selection_error_message(qtx_index, question_state, selection_length)
                sys.exit()
            selection4_text.append(padding_space(line, selection_length))
            continue
        elif question_state == 6:
            if len(line) > selection_length:
                # selection length error
                print_selection_error_message(qtx_index, question_state, selection_length)
                sys.exit()
            selection5_text.append(padding_space(line, selection_length))
            continue
        elif question_state == 7:
            question_count += 1
            question_state = 0

    if question_state:
        # question error check
        print 'Error: Header : ' + str(qtx_index) + ' : ' + genres[qtx_index] + ' Question count = 0 or is not finished.'
        sys.exit()

    question_counts.append(question_count - 1)
    
    for q, s1, s2, s3, s4, s5 \
        in zip(question_texts,selection1_text, selection2_text, selection3_text, selection4_text, selection5_text):
        quiz_cont = [q, s1, s2, s3, s4, s5]
        # AXL[R[h 0x20  xor 0x80 ̑ΏۊO
        # struct.pack('B',(ord(e) ^ 0x80)) if ord(e) <> 0x20 else packed_0x20
        xor_quiz = [ struct.pack('B',(ord(e) ^ 0x80)) \
            if (re.search('.+[^ ]',qc) is not None and len(re.search('.+[^ ]',qc).group(0)) > i) else packed_0x20 \
            for qc in quiz_cont for i, e in enumerate(qc)]

        quiz_contents.append(''.join(xor_quiz))

    question_count = 1

packed_0x0000 = struct.pack('H', 0x00)
packed_0x00 = struct.pack('B',0x00)

# write header
for q_count, genre in zip(question_counts, genres):
# unsigned charnpszName[16]; // ެٖ
    genre_index = genres.index(genre)
    f_5tq.write(genre)
# intreserved_1;
    f_5tq.write(packed_0x0000)
# intnCount; // Yެق̖萔
    f_5tq.write(struct.pack('H', q_count))
# intnOffset; // Yެق̐擪ʒu
    prev_quiz_count = sum(question_counts[:genre_index])
##  offset = genre_bytes * header_count + question_bytes * prev_quiz_count
    offset = header_count + prev_quiz_count
    f_5tq.write(struct.pack('H', offset))
# unsigned charnpsz5td[12]; // v[[f[^t@C
    f_5tq.write(padding_space(os.path.basename(rfile) + '.5TD', 12))
# unsigned charnpszID[8]; // hci"5TAKUQDT"j
    f_5tq.write('5TAKUQDT')
# unsigned charreserved_2[256-16-2-2-2-12-8 = 214];
    for i in xrange(214):
        f_5tq.write(packed_0x00)

# write quiz

quiz_datas += ''.join(quiz_contents)

f_5tq.write(quiz_datas)

# close file

f_5tq.close()

for f_qtx in f_qt:
    f_qtx.close()

